if ($.browser.msie || $.browser.opera) {
    alert('This page is guaranteed to work properly only when viewed in Google Chrome, Mozilla Firefox or Safari. Continue on your own risk.');
}


$.fn.extend({disableSelection: function() {
    this.each(function() {
        this.onselectstart = function() {return false;};
        this.unselectable = 'on';
        $(this).css('-webkit-user-select', 'none');
        $(this).css('-khtml-user-select', 'none');
        $(this).css('-moz-user-select', 'none');
        $(this).css('-o-user-select', 'none');
        $(this).css('user-select', 'none');
    });
}});


if (typeof(console) === 'undefined') {
    console = {
        log: function(msg) {},
        info: function(msg) {},
        warn: function(msg) {},
        error: function(msg) {
            alert(msg);
        }
    };
}


$(function() {
        var G_STATUS_POLL_PERIOD = 100;
        var G_EX_LIST_POLL_PERIOD = 300;

        var G_ERROR_MESSAGE_TIMEOUT = 5000;

        var G_HOME = window.location.protocol + '//' + window.location.host;

        var g_autoselect_current = true;

        var g_cur_date_data = [];

        var g_tra_name_map = {
            0: 'SYN',
            1: 'T1',
            2: 'T2'
        };

        var g_ex_details_headers_map = {
            0: ['Δ ToF', 'Deduct', 'Mark'],
            1: ['ToF', 'ToN', 'Mark'],
            2: ['ToF', 'ToN', 'Mark']
        };


        function set_startstop(start) {
            if (start) {
                $('label[for=start-button] .ui-button-text').text('STOP');
                $('#start-button').attr('checked', 'checked');
            } else {
                $('label[for=start-button] .ui-button-text').text('START');
                $('#start-button').removeAttr('checked');
            }

            $('#start-button').button('refresh');
        }


        function set_tra_n(n) {
            $('#tra-select input').removeAttr('checked');
            $('#tra-select input[value=' + n + ']').attr('checked', 'checked');
            $('#tra-select').buttonset('refresh');
        }


        function update_tmd_status(json, err) {
            var i;
            var sen = json.sensors;
            var pw = json.status;
            var ver = json.software_version;
            var rev = json.firmware_revision;
            var serial = json.serial;
            var reset_status = json.reset_status;

            $('#serial-number').text(serial);
            $('#software-version').text(ver);
            $('#firmware-revision').text(rev);
            $('#reset-status').text(reset_status);

            if (pw === 1) {
                $('#error1:visible:not(:animated)').hide('drop', {direction: 'right'});
            } else if (pw === -1) {
                $('#error1 .error-text').text('TMD not connected!');
                $('#error1:hidden').show('drop', {direction: 'right'});
            } else {
                $('#error1 .error-text').text('TMD working on battery power!');
                $('#error1:hidden').show('drop', {direction: 'right'});
            }

            $('.sensor').removeClass('sensor-on');
            for (i = 0; i < 6; ++i) {
                if (sen[i]) {
                    $('#sensor' + (i + 1)).addClass('sensor-on');
                }
            }

            set_startstop(json.startstop === 'start');
            set_tra_n(json.tra_n);
        }


        function ex_format_start_time(ex) {
            var d = new Date(ex.start_time / 10);

            var h = d.getHours();
            var m = d.getMinutes();

            h = h < 10 ? '0' + h : String(h);
            m = m < 10 ? '0' + m : String(m);

            return h + ':' + m;
        }


        function ex_format_tra_n(ex) {
            var ex_tra = '';

            if (ex.tra_n >= 0) {
                ex_tra += g_tra_name_map[ex.tra_n];
            }

            return ex_tra;
        }


        function ex_format_mark(ex) {
            var ex_mark = '';

            if (ex.tra_n >= 0 && ex.marks[ex.tra_n] !== null) {
                ex_mark += ex.marks[ex.tra_n];
            }

            return ex_mark;
        }


        function ex_format_jumps_n(ex) {
            var ex_jumps = '';

            if (ex.tra_n >= 0 && ex.data[ex.tra_n].length > 0) {
                ex_jumps += ex.data[ex.tra_n].length - 1;
            }

            return ex_jumps;
        }


        function ex_format_comment(ex) {
            return ex.comment;
        }


        function ex_summary_tr(i, ex) {
            var ex_id, cls;
            var r = '';

            r += '<td class="ex-time">'    + ex_format_start_time(ex) + '</td>';
            r += '<td class="ex-tra">'     + ex_format_tra_n(ex)      + '</td>';
            r += '<td class="ex-mark">'    + ex_format_mark(ex)       + '</td>';
            r += '<td class="ex-jumps">'   + ex_format_jumps_n(ex)    + '</td>';
            r += '<td class="ex-comment">' + ex_format_comment(ex)    + '</td>';

            ex_id = ex.start_time;
            cls = i % 2 === 1 ? 'even' : 'odd';
            return '<tr class="' + cls + '" id="' + ex_id + '">' + r + '</tr>';
        }


        function ex_details_set_tbody(tbody) {
            $('#ex-details + .no-data').toggle(tbody === '');
            $('#ex-details').toggle(tbody !== '');

            if ($('#ex-details tbody').html() !== tbody) {
                $('#ex-details tbody').html(tbody);
            }
        }


        function do_update_ex_list(exs) {
            var i, selected_id;
            var last_id = $('#ex-list tbody tr:first').attr('id');
            var new_last_id = '';
            var tbody = '';
            var old_last_ex = null;
            var last_ex = null;

            for (i = 0; i < exs.length; ++i) {
                tbody += ex_summary_tr(i, exs[exs.length - i - 1]);
            }

            if (exs.length > 0) {
                new_last_id = String(exs[exs.length - 1].start_time);
            }

            $('#ex-list + .no-data').toggle(tbody === '');
            $('#ex-list').toggle(tbody !== '');

            selected_id = $('#ex-list tr.selected').attr('id');
            $('#ex-list tr').removeClass('selected');

            if (tbody !== $('#ex-list tbody').html()) {
                $('#ex-list tbody').html(tbody);

                if (g_autoselect_current && new_last_id !== last_id) {
                    $.scrollTo(0);
                    selected_id = $('#ex-list tbody tr:first:not(.selected)').attr('id');
                    $('#ex-list tbody tr:first:not(.selected)').click();
                }
            }

            $('#ex-list tr#' + selected_id).addClass('selected');

            if ($('#ex-list tr.selected').length === 0) {
                ex_details_set_tbody('');
            }

            if (exs.length > 0 && g_cur_date_data.length > 0 &&
                last_id === new_last_id) {
                old_last_ex = g_cur_date_data[g_cur_date_data.length - 1];
                last_ex = exs[exs.length - 1];

                if (last_ex.tra_n >= 0 &&
                    old_last_ex.data[last_ex.tra_n].length !== 11 &&
                    last_ex.data[last_ex.tra_n].length === 11) {
                    if ($('label[for=start-button] .ui-button-text').text() === 'STOP') {
                        send_tmd_cmd('stop', false);
                    }
                }
            }
        }


        function update_ex_list(json, err) {
            var i, id, found;

            if ($('#ex-list tr.selected').length === 0) {
                do_update_ex_list(json);
            } else {
                id = parseInt($('#ex-list tr.selected').attr('id'), 10);
                found = false;

                for (i = 0; i < json.length; ++i) {
                    if (json[i].start_time === id) {
                        handle_ex(json[i]);
                        found = true;
                        break;
                    }
                }

                if (!found) {
                    do_update_ex_list(json);
                }
            }

            g_cur_date_data = json;
        }


        function on_ajax_error(obj, err) {
            $('#error2 .error-text').text('AJAX error: ' + err);
            $('#error2:hidden').show('drop', {direction: 'right'}, function() {
                setTimeout(function() {
                    $('#error2:visible:not(:animated)').hide('drop', {direction: 'right'});
                },
                G_ERROR_MESSAGE_TIMEOUT);
            });
        }


        function start_status_timer() {
            setTimeout(function() {
                $.ajax({
                    url: G_HOME + '/api/tmd/status',
                    dataType: 'json',
                    success: update_tmd_status,
                    error: function(obj, err) {
                        if (err === 'error') {
                            $('#error1 .error-text').text('TMD monitor is not running!');
                            $('#error1:hidden').show('drop', {direction: 'right'});
                        } else {
                            on_ajax_error(null, err);
                        }
                    },
                    complete: start_status_timer
                });
            }, G_STATUS_POLL_PERIOD);
        }


        function do_request_ex_list(d) {
            var dd = $.datepicker.formatDate('yy-mm-dd', d);

            $.ajax({
                url: G_HOME + '/api/exercises/on/' + dd,
                dataType: 'json',
                success: function(json, err) {
                    end_loading();
                    update_ex_list(json, err);
                },
                error: on_ajax_error
            });
        }


        function merge_exs(base, exs) {
            var i, j, e, id;
            var r = [];
            var exs_cur = 0;

            // This is a very special merge, which relies heavily on the fact
            // that two ex lists can only share tail/head

            for (i = 0; i < base.length; ++i) {
                e = base[i];
                id = e.start_time;

                for (j = exs_cur; j < exs.length; ++j) {
                    if (exs[j].start_time === id) {
                        exs_cur = j + 1;
                        e = exs[j];
                        break;
                    }
                }

                r.push(e);
            }

            for (j = exs_cur; j < exs.length; ++j) {
                r.push(exs[j]);
            }

            return r;
        }


        function merge_update_ex_list(json) {
            var j;

            if (!today()) {
                return;
            }

            j = merge_exs(g_cur_date_data, json);

            update_ex_list(j);
        }


        function do_request_ex_list_latest() {
            $.ajax({
                url: G_HOME + '/api/exercises/latest',
                dataType: 'json',
                success: function(json) {
                    setTimeout(start_ex_list_timer, G_EX_LIST_POLL_PERIOD);
                    merge_update_ex_list(json);
                },
                error: function(obj, err) {
                    setTimeout(start_ex_list_timer, G_EX_LIST_POLL_PERIOD);
                    on_ajax_error(obj, err);
                }
            });
        }


        function today() {
            var d1 = new Date();
            var d2 = $('#datepicker').datepicker('getDate');

            var df = $('#datepicker').datepicker('option', 'dateFormat');

            var s1 = $.datepicker.formatDate(df, d1);
            var s2 = $.datepicker.formatDate(df, d2);

            return d2 === null || s1 === s2;
        }


        function start_ex_list_timer() {
            setTimeout(function() {
                if (!today()) {
                    setTimeout(start_ex_list_timer, G_EX_LIST_POLL_PERIOD);
                    return;
                }

                do_request_ex_list_latest();
            },
            G_EX_LIST_POLL_PERIOD);
        }


        function start_loading(d) {
            var dd = $.datepicker.formatDate('yy-mm-dd', d);
            $('#exportxls').attr('href', '/api/exportxls/on/' + dd);
            $('#exportxls').hide();

            $('#loading').addClass('loading');
        }


        function end_loading() {
            $('#loading').removeClass('loading');

            $('#exportxls').show();
        }


        function set_date(d) {
            var df = $('#datepicker').datepicker('option', 'dateFormat');
            $('#datepicker').val($.datepicker.formatDate(df, d));

            start_loading(d);

            do_request_ex_list(d);
        }


        function ex_details_tr(i, row) {
            var cls;
            var r = '';

            r += '<td class="ex-details-jump-n">' + i      + '</td>';
            r += '<td class="ex-details-col1">'   + (row[0] !== null ? row[0] : '') + '</td>';
            r += '<td class="ex-details-col2">'   + (row[1] !== null ? row[1] : '') + '</td>';
            r += '<td class="ex-details-col3">'   + (row[2] !== null ? row[2] : '') + '</td>';

            cls = i % 2 === 1 ? 'even' : 'odd';
            return '<tr id="' + i + '" class="' + cls + '">' + r + '</tr>';
        }


        function handle_ex(ex, err) {
            var i;
            var new_exs = [];

            for (i = 0; i < g_cur_date_data.length; ++i) {
                if (g_cur_date_data[i].start_time === ex.start_time) {
                    new_exs = g_cur_date_data.slice(0, i).concat([ex], g_cur_date_data.slice(i + 1));
                    break;
                }
            }

            do_update_ex_list(new_exs);

            setup_ex_details(ex);

            g_cur_date_data = new_exs;
        }


        function setup_ex_details(ex) {
            var i, tbody;

            if (parseInt($('#ex-list tr.selected').attr('id'), 10) !== ex.start_time) {
                return;
            }

            tbody = '';

            if (ex.tra_n >= 0) {
                $('#ex-details thead td.ex-details-col1').text(g_ex_details_headers_map[ex.tra_n][0]);
                $('#ex-details thead td.ex-details-col2').text(g_ex_details_headers_map[ex.tra_n][1]);
                $('#ex-details thead td.ex-details-col3').text(g_ex_details_headers_map[ex.tra_n][2]);

                if (ex.data[ex.tra_n] !== null) {
                    for (i = 0; i < ex.data[ex.tra_n].length; ++i) {
                        tbody += ex_details_tr(i, ex.data[ex.tra_n][i]);
                    }
                }
            }

            ex_details_set_tbody(tbody);

            // Little hack to use only standard attributes
            $('#ex-details').attr('class', ex.start_time);

            $('#ex-details-comment:not(:focus)').val(ex.comment);
            $('#ex-details-trampoline:not(:focus) option').removeAttr('selected');
            $('#ex-details-trampoline:not(:focus) option[value="' + ex.tra_n + '"]').attr('selected', 'selected');
        }


        function load_ex(id) {
            $.ajax({
                url: G_HOME + '/api/exercises/' + id,
                dataType: 'json',
                success: handle_ex,
                error: on_ajax_error
            });
        }


        function send_tmd_cmd(cmd, need_send_tra_n) {
            console.log('sending ' + cmd);

            $.ajax({
                url: G_HOME + '/api/tmd/' + cmd,
                type: 'POST',
                success: function() {
                    if (need_send_tra_n) {
                        send_tra_n();
                    }
                },
                error: on_ajax_error
            });
        }


        function send_tra_n(tra) {
            if (typeof(tra) === 'undefined') {
                tra = $('#tra-select label[aria-pressed=true]').prev().attr('value');
            }

            console.log('sending tra_n ' + tra);

            $.ajax({
                url: G_HOME + '/api/tmd/tra_n',
                type: 'POST',
                data: tra,
                processData: false,
                error: on_ajax_error
            });
        }


        function init_buttons() {
            $('#start-button').button();
            $('#tra-select').buttonset();

            $('#start-button + label').mouseup(function() {
                if ($('#start-button + label[aria-pressed=true]').length > 0) {
                    send_tmd_cmd('stop', false);
                } else {
                    send_tmd_cmd('start', true);
                }
            });

            $('#tra-select').change(function() {
                send_tra_n();
            });

            $('#controls *').disableSelection();
        }


        function init_ex_details_controls() {
            $('#ex-details-comment').autocomplete({
                source: '/api/comment_autocomplete',
                delay: 0
            });

            $('#ex-details-comment').change(function() {
                var id = $('#ex-details').attr('class');
                var data = $(this).val();
                $(this).blur();

                console.log('sending comment for ' + id + ': ' + data);

                $.ajax({
                    url: G_HOME + '/api/exercises/' + id + '/comment',
                    type: 'POST',
                    data: data,
                    processData: false,
                    success: function() {
                        load_ex(id);
                    },
                    error: on_ajax_error
                });
            });

            $('#ex-details-trampoline').change(function() {
                var id = $('#ex-details').attr('class');
                var data = $('#ex-details-trampoline option:selected').val();

                console.log('sending tra_n for ' + id + ': ' + data);

                $.ajax({
                    url: G_HOME + '/api/exercises/' + id + '/tra_n',
                    type: 'POST',
                    data: data,
                    processData: false,
                    success: function() {
                        load_ex(id);
                    },
                    error: on_ajax_error
                });
            });
        }


        function set_autoselect_current(v) {
            g_autoselect_current = v;
        }


        function init_advanced() {
            $('#advanced').dialog({
                modal: true,
                autoOpen: false,
                draggable: false,
                resizable: false,
                width: 400,
                height: 330
            });

            $('#advanced-link').click(function() {
                // XXX
                $.scrollTo(0);

                $('#advanced').dialog('open');
            });

            $('#opt-autoselect-current').change(function() {
                var v = $(this).attr('checked');
                set_autoselect_current(v);
            });
        }


        function init_datepicker() {
            function set_datepicker(reg) {
                var dp = $('#datepicker');
                dp.datepicker('destroy');
                $.datepicker.setDefaults($.datepicker.regional[reg]);
                dp.datepicker($.datepicker.regional[reg]);
                dp.datepicker('option', 'dateFormat', 'DD, d MM, yy');
                dp.datepicker('option', 'autoSize', true);
                dp.datepicker('option', 'maxDate', 0);
                dp.datepicker('option', 'showAnim', 'drop');
            }

            set_datepicker('en-GB');

            $('#opt-locale').change(function() {
                var d = $('#datepicker').datepicker('getDate');
                set_datepicker($(this).val());
                $('#datepicker').datepicker('setDate', d);
            });

            $('#datepicker').change(function() {
                var d = $('#datepicker').datepicker('getDate');
                set_date(d);
            });
        }


        function init_live() {
            $('#ex-list tbody tr').live('click', function() {
                var id;

                $('#ex-list tr').removeClass('selected');
                $(this).addClass('selected');

                id = $(this).attr('id');
                load_ex(id);
            });
        }


        function init_ui() {
            init_buttons();
            init_ex_details_controls();
            init_advanced();
            init_datepicker();
            init_live();

            $(document).keypress(function(event) {
                if ($('#ex-details-comment').is(":focus")) {
                    if (event.which === 13) {
                        $('#ex-details-comment').change();
                    }
                    return;
                }

                event.preventDefault();

                if (event.which === 13) {
                    $('#ex-details-comment').focus();
                } else if (event.which === 32) {
                    $('#start-button + label').mouseup();
                } else if (event.which === 48) {
                    send_tra_n('0');
                    $('label[for=syn-button]').click();
                } else if (event.which === 49) {
                    send_tra_n('1');
                    $('label[for=tra1-button]').click();
                } else if (event.which === 50) {
                    send_tra_n('2');
                    $('label[for=tra2-button]').click();
                }
            });
        }


        init_ui();

        start_status_timer();
        start_ex_list_timer();
        set_date(new Date());
});

